@echo off
setlocal EnableDelayedExpansion

rem Automatic multi-level multi-option menu system
rem Antonio Perez Ayala - 2022/02/09

if "%~1" neq "" if "%~1" neq "/?" goto begin
echo Activate a multi-level multi-option menu system
echo/
echo    %~NX0 menuFolder
echo/
echo The menu is defined into menuFolder via subfolders, .txt and .bat files.
echo The first character of folder/file names must be CHOICE.EXE options
echo and the second character must be a hypen (-)
echo/
echo Review the extensive example at "Windows-DOS Commands Help" folder
goto :EOF

:begin
rem Select menu folder and get its name for title and header
if not exist "%~1\" echo Menu folder not exist: %1 & goto :EOF
set "aux=%~N1"
set "myHeader="
for /L %%i in (0,1,80) do if "!aux:~%%i,1!" neq "" set "myHeader=!myHeader! !aux:~%%i,1!"
for %%a in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do set "myHeader=!myHeader:%%a=%%a!"
set "spaces=         "
title %1
color 1F
set "level=0"
call :nextLevel %1
color
cls
goto :EOF


:nextLevel subFolder
rem Enter next subFolder level and get directories, .txt and .bat files
setlocal EnableDelayedExpansion
for /F "delims==" %%a in ('set option[ 2^>NUL') do set "%%a="
set "choices= 0"
cd %1
for /F "tokens=1* delims=-" %%a in ('dir /B *. *.txt *.bat') do (
   set "option[%%a]=%%b"
   set "choices=!choices!%%a"
)

:thisLevel
rem Show menu options at this level
cls
echo/
echo    %spaces%%myHeader%
echo/
echo/
for /L %%i in (1,1,%level%) do (
   set /A "spc=%%i*3"
   for %%n in ("!spc!") do echo    !spaces:~%%~n!!header[%%i]!& echo/
)
for /F "tokens=2-4 delims=[]=." %%a in ('set option[') do echo    %%a- %%b
echo/
echo/

rem Select option and activate it: show .txt file, run .bat file or open subfolder
choice /N /C %choices% /M "Select the desired option (0 to exit):"
set "choice=!choices:~%errorlevel%,1!"
if "%choice%" equ "0" cd .. & exit /B
if /I "!option[%choice%]:~-4!" equ ".txt" (
   echo/
   type "%choice%-!option[%choice%]!"
   echo/
   pause
) else if /I "!option[%choice%]:~-4!" equ ".bat" (
   echo/
   call "%choice%-!option[%choice%]!"
   echo/
   pause
) else (
   set /A "level+=1"
   set "header[!level!]=%choice%-!option[%choice%]!"
   call :nextLevel "%choice%-!option[%choice%]!"
   set /A "level-=1"
)
goto thisLevel
